from osv import fields, osv
import logging

class hr_employee(osv.osv):
	_inherit = "hr.employee"
	
	_columns = {
		'acf_children_at_school': fields.integer('Children at school'),
		'acf_children_under_18': fields.integer('Children under 18'),
		'acf_code': fields.char('Code', size=64, required=True),
	} 
	
	_defaults = {
		'acf_code': lambda obj, cr, uid, context: obj._get_next_acf_code(cr, uid, context)
	}
	_sql_constraints = [
		('acf_code_uniq', 'UNIQUE (acf_code)', 'The Code must be unique!')
	    ]

	def _get_next_acf_code(self, cr, uid, context):
	    return self.pool.get('ir.sequence').get(cr, uid, 'acf_custom.employee')
		
	#http://stackoverflow.com/questions/10806362/in-openerp-how-can-i-force-sql-to-run-when-a-module-is-installed
	def _upgrade_01_0000(self, cr, uid, ids=None, context=None):
	    logger = logging.getLogger("openerp.addons.acf_custom.hr_employee")
	    logger.info("_upgrade_01_0000 starting")

	    ids = self.search(cr, uid, [], context=context)
	    for empl in self.browse(cr, uid, ids, context=context):
		
		code = empl.acf_code or self._get_next_acf_code(cr, uid, context)	  
		
		logger.info("Updating employee ACF code from %s to %s for ID: %s", empl.acf_code, code, empl.id)
		    
		empl.acf_code = code

	    logger.info("_upgrade_01_0000 finished")
		
	    return True
        
hr_employee() 
