
from osv import fields, osv

class hr_payslip(osv.osv):
    _inherit = 'hr.payslip'
    
    _columns = {
        'struct_id': fields.related('contract_id', 'struct_id', type='many2one', relation='hr.payroll.structure', string='Salary Structure', store=True, readonly=True),
        'contract_id': fields.many2one('hr.contract', 'Contract', required=False, readonly=True, states={'draft': [('readonly', False)]}, domain="[('employee_id','=',employee_id),('date_start','<=',date_to),'|',('date_end','>=',date_from),('date_end','=',False)]"),        
    }
    
    def onchange_employee_id(self, cr, uid, ids, date_from, date_to, employee_id=False, contract_id=False, context=None):
            
	import time
	from datetime import datetime
	from tools.translate import _
	import tools
      
        empolyee_obj = self.pool.get('hr.employee')

        if context is None:
            context = {}
            
        #defaults
        res = {'value':{
                      'name':'',
                      'company_id':False,
                      }
            }
            
        if (not employee_id) or (not date_from) or (not date_to):
            return res

        ttyme = datetime.fromtimestamp(time.mktime(time.strptime(date_from, "%Y-%m-%d")))
        employee_rec = empolyee_obj.browse(cr, uid, employee_id, context=context)
        res['value'].update({
                    'name': _('Salary Slip of %s for %s') % (employee_rec.name, tools.ustr(ttyme.strftime('%B-%Y'))),
                    'company_id': employee_rec.company_id.id
        })

        res['value'].update(
                    self.onchange_contract_id(cr, uid, ids, date_from, date_to, employee_id, contract_id, context)['value']
		    )       
        
        return res

    def onchange_contract_id(self, cr, uid, ids, date_from, date_to, employee_id=False, contract_id=False, context=None):

        empolyee_obj = self.pool.get('hr.employee')
	contract_obj = self.pool.get('hr.contract')
        worked_days_obj = self.pool.get('hr.payslip.worked_days')
        input_obj = self.pool.get('hr.payslip.input')
        
        if context is None:
            context = {}            
            
	#delete old worked days lines
        old_worked_days_ids = ids and worked_days_obj.search(cr, uid, [('payslip_id', '=', ids[0])], context=context) or False
        if old_worked_days_ids:
            worked_days_obj.unlink(cr, uid, old_worked_days_ids, context=context)

        #delete old input lines
        old_input_ids = ids and input_obj.search(cr, uid, [('payslip_id', '=', ids[0])], context=context) or False
        if old_input_ids:
            input_obj.unlink(cr, uid, old_input_ids, context=context)
            
            
        res = {'value':{
		  'line_ids': [],
		  'input_line_ids': [],
		  'worked_days_line_ids': [],
		  'struct_id': False,
		  'contract_id': False,
                 }
              }
        
        contract_ids = []        
        contract_record = False
        
        if contract_id:
	  
	    contract_ids = [contract_id]
	    contract_record = contract_obj.browse(cr, uid, contract_id, context=context)
            
        else:
            # get all valid contract_ids of an employee
	    employee_rec = empolyee_obj.browse(cr, uid, employee_id, context=context)
            contract_ids = self.get_contract(cr, uid, employee_rec, date_from, date_to, context=context)
            
            # if exactly one only exists, use it
            if len(contract_ids) == 1:
		contract_record = contract_obj.browse(cr, uid, contract_ids[0], context=context)
            

	if contract_record:
	  	    res['value'].update({
			'struct_id': contract_record.struct_id.id,
			'contract_id': contract_record.id
			})

	    
        #computation of the salary input
        worked_days_line_ids = self.get_worked_day_lines(cr, uid, contract_ids, date_from, date_to, context=context)
        input_line_ids = self.get_inputs(cr, uid, contract_ids, date_from, date_to, context=context)
        res['value'].update({
                    'worked_days_line_ids': worked_days_line_ids,
                    'input_line_ids': input_line_ids,
        })
        
        return res

hr_payslip()